package com.wdkl.ncs.app.powercontroltest;

import androidx.appcompat.app.AppCompatActivity;
import androidx.preference.PreferenceManager;

import android.annotation.SuppressLint;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.nfc.FormatException;
import android.nfc.NdefMessage;
import android.nfc.NdefRecord;
import android.nfc.NfcAdapter;
import android.nfc.Tag;
import android.nfc.tech.MifareClassic;
import android.nfc.tech.Ndef;
import android.nfc.tech.NfcA;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.provider.Settings;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;

import com.aventrix.jnanoid.jnanoid.NanoIdUtils;
import com.google.android.material.textfield.TextInputEditText;
import com.wdkl.ncs.app.powercontroltest.common.Constants;

import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.StringUtils;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.nio.Buffer;
import java.nio.ByteBuffer;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import java.util.Timer;
import java.util.TimerTask;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.zip.CRC32;

public class MainActivity extends SerialPortActivity {
    String TAG = "MainActivity";
    TextView tv_return = null;
    TextView tv_send = null;
    TextView tv_receive = null;
    EditText device_address = null;
    EditText light_address = null;
    EditText custom_command = null;
    NfcAdapter mNfcAdapter;
    PendingIntent pIntent;
    Timer timer = new Timer();
    Integer[] status = new Integer[]{
            0xFFFFFFFE, 0xFFFFFFFD, 0xFFFFFFFB, 0xFFFFFFF7,
            0xFFFFFFEF, 0xFFFFFFDF, 0xFFFFFFBF, 0xFFFFFF7F,
            0xFFFFFEFF, 0xFFFFFDFF, 0xFFFFFBFF, 0xFFFFF7FF,
            0xFFFFEFFF, 0xFFFFDFFF, 0xFFFFBFFF, 0xFFFF7FFF,
            0xFFFEFFFF, 0xFFFDFFFF, 0xFFFBFFFF, 0xFFF7FFFF,
            0xFFEFFFFF, 0xFFDFFFFF, 0xFFBFFFFF, 0xFF7FFFFF
    };

    Map<String,Long> receivedCache = new HashMap<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        final Button buttonSetup = (Button) findViewById(R.id.ButtonSetup);
        buttonSetup.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
//                openNetworkDebug();
                startActivity(new Intent(MainActivity.this, SettingsActivity.class));
            }
        });
        final Button rebootAppButton = (Button) findViewById(R.id.RebootApp);
        rebootAppButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                openSerial();
                init();
            }
        });
        this.init();
        initNfc();
        tv_return = findViewById(R.id.tv_return);
        tv_send = findViewById(R.id.tv_send);
        tv_receive = findViewById(R.id.tv_receive);
        device_address = findViewById(R.id.device_address);
        light_address = findViewById(R.id.light_address);
        custom_command = findViewById(R.id.custom_command);
        registerReceiver(new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                Tag tag = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
                Long cardcode = Long.valueOf(bytesToHex(tag.getId()),16);
                Log.i("卡号", cardcode.toString());
                try {
                    writeMifareClassic("$123456#",intent);
                } catch (IOException e) {
                    e.printStackTrace();
                }
//                String s = readMifareClassic(intent);
//                Log.i("卡数据", s);
//
//                for (String tech : tag.getTechList()) {
//                    Log.i(TAG, "卡片类型: "+tech);
//                }
            }
        },new IntentFilter("NFC_DISCOVERYED"));
    }

    private String readMifareClassic(Intent intent) {
        String info = "";
        List<byte[]> list = new ArrayList<>();
        boolean auth = false;
        //读取TAG
        Tag tag = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
        MifareClassic mfc = MifareClassic.get(tag);
        try {
            mfc.connect();
            if (mfc.isConnected()) {
                int sectorCount = mfc.getSectorCount();//获取TAG中包含的扇区数
                if (sectorCount == 16) {
                    int bindex = mfc.sectorToBlock(1);
                    auth = mfc.authenticateSectorWithKeyA(1,
                            MifareClassic.KEY_DEFAULT);
                    if (auth) {
                        byte[] data = mfc.readBlock(bindex + 1);
                        info = new String(data, Charset.forName("utf-8"));
                        Log.e(TAG, "读取写入的数据: " + info);
                    }
                }
//                for (int j = 0; j < sectorCount; j++) {
//                    auth = mfc.authenticateSectorWithKeyA(j,
//                            MifareClassic.KEY_DEFAULT);
//                    int bCount;
//                    int bIndex;
//                    if (auth) {
//                        // 读取扇区中的块
//                        bCount = mfc.getBlockCountInSector(j);
//                        bIndex = mfc.sectorToBlock(j);
//                        for (int i = 0; i < bCount; i++) {
//                            byte[] data = mfc.readBlock(bIndex);
//                            if (i < bCount - 1) {
//                                if (!bytesToHexString(data).equals("0x00000000000000000000000000000000")) {
//                                    list.add(data);
//                                }
//                            }
//                            bIndex++;
//                        }
//                    }
//                }
//                if (list.size() > 0) {
//                    byte[] aa = new byte[list.size() * list.get(0).length];
//                    for (int i = 0; i < list.size(); i++) {
//                        byte[] bytes = list.get(i);
//                        System.arraycopy(bytes, 0, aa, bytes.length * i, bytes.length);
//                    }
//                    info = new String(aa, Charset.forName("utf-8"));
//                    Log.i(TAG, "readMifareClassic: "+info);
//                }
            }
        } catch (Exception e) {
            Log.e(TAG, e.getMessage());
        } finally {
            try {
                mfc.close();
            } catch (IOException e) {
                Log.e(TAG, e.getMessage());
            }
        }
        return info;
    }


    public void writeMifareClassic(String data, Intent intent) throws IOException {
        Tag tag = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
        MifareClassic mfc = MifareClassic.get(tag);
        try {
            mfc.connect();
            int sectorCount = mfc.getSectorCount();//获取TAG中包含的扇区数
            if (sectorCount == 16) {
                byte[] bytes = new byte[16];
                System.arraycopy(data.getBytes("utf-8"), 0, bytes, 0, data.getBytes().length);

                int bIndex = mfc.sectorToBlock(1);
                if (mfc.authenticateSectorWithKeyA(1,
                        MifareClassic.KEY_DEFAULT)) {
                    mfc.writeBlock(bIndex + 1, bytes);
                }
            }
//
//            for (int j = 0; j < sectorCount; j++) {
//                if (mfc.authenticateSectorWithKeyA(j,
//                        MifareClassic.KEY_DEFAULT)) {
//                    // 读取扇区中的块
//                    int bCount = mfc.getBlockCountInSector(j);
//                    int bIndex = mfc.sectorToBlock(j);
//                    for (int i = 0; i < bCount - 1; i++) {
//                        if (!bytesToHexString(mfc.readBlock(bIndex + i)).equals("0x00000000000000000000000000000000")) {
//                            mfc.writeBlock(bIndex + i, new byte[16]);
//                        }
//                    }
//                }
//            }
//            byte[] bytes = new byte[16];
//            System.arraycopy(data.getBytes(), 0, bytes, 0, data.getBytes().length);
//            if (mfc.authenticateSectorWithKeyA(1,
//                    MifareClassic.KEY_NFC_FORUM)) {
//                mfc.writeBlock(4, bytes);
//            }
            Log.e(TAG, "写入MifareClassic成功");
        } finally {
            try {
                mfc.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * 读取数据
     *
     * @param tag Tag
     */
    private void readData(Tag tag) {
        // 从Tag中获取Ndef信息
        NfcA ndef = NfcA.get(tag);
        try {
            // 连接
            ndef.connect();
            byte[] atqa = ndef.getAtqa();
            Log.i("卡号2", bytesToHex(atqa));
//            readData: type: android.ndef.unknown, size: 250, message: NdefMessage [NdefRecord tnf=1 type=54 payload=027A68E4BDA0E5A5BD]
//            Log.e(TAG, "readData: type: " + ndef.getType() + ", size: " + ndef.getMaxSize() + ", message: " + ndef.getNdefMessage().toString());
//            // 获取NdefMessage消息
//            NdefMessage ndefMessage = ndef.getNdefMessage();
//            // 获取NdefRecord记录
//            //ndefMessage.getRecords();
//            // 遍历数组
//            StringBuilder stringBuilder = new StringBuilder();
//            // 文本
//            String text="";
//            for (NdefRecord ndefRecord : ndefMessage.getRecords()) {
//                text = parseNdefRecord(ndefRecord);
//                if (!TextUtils.isEmpty(text)) {
//                    stringBuilder.append(text);
//                }
//            }
//            // 设置文本
//            Log.e(TAG, "readData: "+text);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 解析NdefRecord数据
     *
     * @param ndefRecord NdefRecord记录
     */
    private String parseNdefRecord(NdefRecord ndefRecord) {
        // 判断是否为文本格式数据
        if (NdefRecord.TNF_WELL_KNOWN != ndefRecord.getTnf()) {
            return "";
        }
        if (!Arrays.equals(ndefRecord.getType(), NdefRecord.RTD_TEXT)) {
            return "";
        }

        try {
            // 获得字节流
            byte[] payload = ndefRecord.getPayload();
            // 获得编码格式
            String textEncoding = ((payload[0] & 0x80) == 0) ? "utf-8" : "utf-16";
            // 获得语言编码长度
            int languageCodeLength = payload[0] & 0x3f;
            // 语言编码
            String languageCode = new String(payload, 1, languageCodeLength, "US-ASCII");
            // 获取文本
            return new String(payload, languageCodeLength + 1, payload.length - languageCodeLength - 1, textEncoding);
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return "";
    }

    /**
     * 初始化
     */
    private void initNfc() {
        mNfcAdapter = NfcAdapter.getDefaultAdapter(this);
        pIntent = PendingIntent.getBroadcast(this, 0,
                //在Manifest里或者这里设置当前activity启动模式，否则每次向阳NFC事件，activity会重复创建
                // 当然也要按照具体情况来，你设置成singleTask也不是不行，
                new Intent("NFC_DISCOVERYED"),
                PendingIntent.FLAG_UPDATE_CURRENT);
    }
// new Intent(this, getClass()).addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP),
//    @Override
//    protected void onNewIntent(Intent intent) {
//        super.onNewIntent(intent);
//        //这里必须setIntent，set  NFC事件响应后的intent才能拿到数据
//        setIntent(intent);
//        Log.i("FlashTestNFC", "onNewIntent");
//        Tag tag = getIntent().getParcelableExtra(NfcAdapter.EXTRA_TAG);
////        processIntent(intent);
//        //TODO 获取数据进行下一步处理
//        Long cardcode = Long.valueOf(bytesToHex(tag.getId()),16);
//        Log.i("卡号", cardcode.toString());
//        Log.i("FlashTestNFC--Tag", bytesToHex(tag.getId()));
//        tv_receive.setText("卡号："+cardcode);
//    }


    private void processIntent(Intent intent) {
        //取出封装在intent中的TAG
        Tag tagFromIntent = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
        for (String tech : tagFromIntent.getTechList()) {
            System.out.println(tech);
        }
        boolean auth = false;
        //读取TAG
        MifareClassic mfc = MifareClassic.get(tagFromIntent);
        try {
            String metaInfo = "";
            //Enable I/O operations to the tag from this TagTechnology object.
            mfc.connect();
            int type = mfc.getType();//获取TAG的类型
            int sectorCount = mfc.getSectorCount();//获取TAG中包含的扇区数
            String typeS = "";
            switch (type) {
                case MifareClassic.TYPE_CLASSIC:
                    typeS = "TYPE_CLASSIC";
                    break;
                case MifareClassic.TYPE_PLUS:
                    typeS = "TYPE_PLUS";
                    break;
                case MifareClassic.TYPE_PRO:
                    typeS = "TYPE_PRO";
                    break;
                case MifareClassic.TYPE_UNKNOWN:
                    typeS = "TYPE_UNKNOWN";
                    break;
            }
            metaInfo += "卡片类型：" + typeS + "\n共" + sectorCount + "个扇区\n共"
                    + mfc.getBlockCount() + "个块\n存储空间: " + mfc.getSize() + "B\n";
            for (int j = 0; j < sectorCount; j++) {
                //Authenticate a sector with key A.
                auth = mfc.authenticateSectorWithKeyA(j,
                        MifareClassic.KEY_DEFAULT);
                int bCount;
                int bIndex;
                if (auth) {
                    metaInfo += "Sector " + j + ":验证成功\n";
                    // 读取扇区中的块
                    bCount = mfc.getBlockCountInSector(j);
                    bIndex = mfc.sectorToBlock(j);
                    for (int i = 0; i < bCount; i++) {
                        byte[] data = mfc.readBlock(bIndex);
                        metaInfo += "Block " + bIndex + " : "
                                + bytesToHexString(data) + "\n";
                        bIndex++;
                    }
                } else {
                    metaInfo += "Sector " + j + ":验证失败\n";
                }
            }
            Log.i(TAG, "processIntent: " + metaInfo);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private String bytesToHexString(byte[] src) {
        StringBuilder stringBuilder = new StringBuilder("0x");
        if (src == null || src.length <= 0) {
            return null;
        }
        char[] buffer = new char[2];
        for (int i = 0; i < src.length; i++) {
            buffer[0] = Character.forDigit((src[i] >>> 4) & 0x0F, 16);
            buffer[1] = Character.forDigit(src[i] & 0x0F, 16);
            System.out.println(buffer);
            stringBuilder.append(buffer);
        }
        return stringBuilder.toString();
    }

    private byte[] packageData(String msg) {
        byte[] content = msg.getBytes();
        int length = content.length + 6;
        byte[] lengthArray = ByteBuffer.allocate(4).putInt(length + 8).array();
        byte[] start = String2Byte("AA55");

        ByteBuffer buffer = ByteBuffer.allocate(length);
        buffer.put(start);
        buffer.put(lengthArray);
        buffer.put(content);
        CRC32 crc32 = new CRC32();
        crc32.update(buffer.array());
        long value = crc32.getValue();
        Log.i(TAG, "Crc: " + value);
        byte[] crc = ByteBuffer.allocate(8).putLong(value).array();
        ByteBuffer buffer1 = ByteBuffer.allocate(length + 8);
        buffer1.put(buffer.array());
        buffer1.put(crc);
        return buffer1.array();
    }

    /**
     * 消息分包发送，包格式如下：每个包可传输的数据内容是发送缓冲区的大小减去18个字节。18个字节为包控制数据
     * 保证接收端接收后可校验包的正确性。假设发送缓冲区是60个字节，那么每个包最多可发送42个字节的消息数据，
     * 因为包已经校验准确性，接收端只需合并包内容数据即可。消息id使用整个消息内容的crc校验值
     * 帧头 有效数据长度 包序 总包数 消息id 包内容        crc包校验
     * 2B      1B      1B  1B     8B    MAX-18          8B
     *
     * @param msg
     * @param outputStream
     * @param packageLength
     */
    private void sendMsg(String msg, OutputStream outputStream, int packageLength) throws IOException {


        char[] alphabet = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_".toCharArray();

        try {
            byte[] msgBytes = msg.getBytes();
            //msgBytesLength 要发送的消息总长度，
            int msgBytesLength = msgBytes.length;
            //packageContentLength 每个包可发送的长度
            int packageContentLength = packageLength - 21;
            //要发送包的个数
            int packages = msgBytesLength / packageContentLength + (msgBytesLength % packageContentLength != 0 ? 1 : 0);
//            String msgId = NanoIdUtils.randomNanoId(new Random(), alphabet, 5);
            CRC32 crc32Msg = new CRC32();
            crc32Msg.update(msgBytes);
            long msgId = crc32Msg.getValue();
            byte[] packageContent = new byte[packageContentLength];
            byte[] start = String2Byte("A3B1");
            for (int i = 0; i < packages; i++) {
                ByteBuffer buffer = ByteBuffer.allocate(packageLength - 8); //校验数据之前的数据
                buffer.put(start);
                //消息内容实际数据长度
                byte contentLength = (byte) Math.min(packageContentLength, msgBytesLength - i * packageContentLength);
                buffer.put(contentLength);
                //包序
                buffer.put((byte) (i + 1));
                //总包数
                buffer.put((byte) packages);
                //消息id字节
                byte[] msgIdBytes = ByteBuffer.allocate(8).putLong(msgId).array(); //msgId.getBytes();
                buffer.put(msgIdBytes);
                //包内容
                byte[] subarray = ArrayUtils.subarray(msgBytes, i * packageContentLength, i * packageContentLength + contentLength);
                ByteBuffer wrap = ByteBuffer.allocate(packageContentLength).put(subarray);
                if (subarray.length < packageContentLength) {
                    wrap.put(new byte[packageContentLength - subarray.length]);
                }
                buffer.put(wrap.array());
                CRC32 crc32 = new CRC32();
                //计算校验
                crc32.update(buffer.array());
                Log.i(TAG, "sendMsg: "+ArrayUtils.toString(buffer.array()));
                long value = crc32.getValue();
                Log.i(TAG, "Crc: " + value);
                byte[] crc = ByteBuffer.allocate(8).putLong(value).array();
                ByteBuffer bufferSend = ByteBuffer.allocate(packageLength);
                //把crc校验加入到包尾
                bufferSend.put(buffer.array());
                bufferSend.put(crc);
                //发送包
                Log.i(TAG, "sendMsg: 发送："+ArrayUtils.toString(bufferSend.array()));
                outputStream.write(bufferSend.array());
            }


        } catch (IOException e) {
            throw e;
        }

    }


    @Override
    protected void onPause() {
        super.onPause();
        Log.i("FlashTestNFC", "onPause");
        if (mNfcAdapter != null) {
            mNfcAdapter.disableForegroundDispatch(this);
        }
    }


    @Override
    protected void onResume() {
        super.onResume();
        Log.i("FlashTestNFC", "onResume");
        if (mNfcAdapter != null) {
            //添加intent-filter
            IntentFilter ndef = new IntentFilter(NfcAdapter.ACTION_NDEF_DISCOVERED);
            IntentFilter tag = new IntentFilter(NfcAdapter.ACTION_TAG_DISCOVERED);
            IntentFilter tech = new IntentFilter(NfcAdapter.ACTION_TECH_DISCOVERED);
            IntentFilter[] filters = new IntentFilter[]{ndef, tag, tech};

            //添加 ACTION_TECH_DISCOVERED 情况下所能读取的NFC格式，这里列的比较全，实际我这里是没有用到的，因为测试的卡是NDEF的
            String[][] techList = new String[][]{
                    new String[]{
                            "android.nfc.tech.Ndef",
                            "android.nfc.tech.NfcA",
                            "android.nfc.tech.NfcB",
                            "android.nfc.tech.NfcF",
                            "android.nfc.tech.NfcV",
                            "android.nfc.tech.NdefFormatable",
                            "android.nfc.tech.MifareClassic",
                            "android.nfc.tech.MifareUltralight",
                            "android.nfc.tech.NfcBarcode"
                    }
            };
            mNfcAdapter.enableForegroundDispatch(this, pIntent, filters, techList);
        }
    }

    /**
     * 2进制to 16进制
     *
     * @param src
     * @return
     */
    private static String bytesToHex(byte[] src) {
        StringBuffer sb = new StringBuffer();
        if (src == null || src.length <= 0) {
            return null;
        }
        String sTemp;
        for (int i = 0; i < src.length; i++) {
            sTemp = Integer.toHexString(0xFF & src[i]);
            if (sTemp.length() < 2) {
                sb.append(0);
            }
            sb.append(sTemp.toUpperCase());
        }
        return sb.toString();
    }

    private void init() {
        TextView settingInfo = (TextView) findViewById(R.id.setttingInfo);
        StringBuilder sb = new StringBuilder();
        SharedPreferences sp = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
        Log.i("Application", "getSerialPort: " + sp.getString("serialDeivce", ""));
        String path = sp.getString("serialDeivce", ""); //sp.getString("DEVICE", "");
        int baudrate = Integer.decode(sp.getString("baudRate", "115200")); //Integer.decode(sp.getString("BAUDRATE", "-1"));
        int parity = Integer.decode(sp.getString("parity", "0"));
        int dataBits = Integer.decode(sp.getString("dataBits", "8"));
        int stopBits = Integer.decode(sp.getString("stopBits", "1"));

        sb.append("串口号：" + path + "\n");
        sb.append("波特率：" + baudrate + "\n");
        sb.append("校验位：" + parity + "\n");
        sb.append("数据位：" + dataBits + "\n");
        sb.append("停止位：" + stopBits + "\n");

        settingInfo.setText(sb.toString());
        TextView tcpstatus = (TextView) findViewById(R.id.serialStatus);
        if (Constants.SERIAL_PORT_STATUS) {
            tcpstatus.setText("正常");
            tcpstatus.setTextColor(getResources().getColor(R.color.green));
        } else {
            tcpstatus.setText(Constants.SERIAL_PORT_FAIL_RESON);
            tcpstatus.setTextColor(getResources().getColor(R.color.red));
        }

    }

    Set<String> msgs = new HashSet<>();

    @Override
    protected void onDataReceived(byte[] buffer, int size) {
        String data = new String(buffer, 0, size);
//        String s = Build.ID.toString();
//        String origin=data;
//        Pattern p = Pattern.compile("[\\$](.*?)[\\#]");
//        Matcher m = p.matcher(data.toUpperCase());
//
//       if(m.find()){
//           origin =m.toMatchResult().group();
//       }else{
//           origin="";
//       }
        Log.i(TAG, "onDataReceived: " + data);
        StringBuilder sb = new StringBuilder();
        sb.append(",bytes:");
        for (byte b : buffer) {
            sb.append(b + ",");
        }
        long ctime = new Date().getTime();
        Iterator<Map.Entry<String, Long>> iterator = receivedCache.entrySet().iterator();
        while (iterator.hasNext()){
            if(iterator.next().getValue()-ctime>50000){
                iterator.remove();
            }
        }

        Random random = new Random();
        final String org = data;
        int i = random.nextInt(200)+1;
        int j=random.nextInt(200)+200;
        Log.i(TAG, "onDataReceivedi: " + i);
        if(!receivedCache.containsKey(data)||receivedCache.containsKey(data)&&receivedCache.get(data)-ctime>60000) {
            receivedCache.put(data,new Date().getTime());
            Integer[] taskTime = new Integer[]{i,j};
            for (Integer t : taskTime) {
                timer.schedule(new TimerTask() {
                    @Override
                    public void run() {
                        try {
                            Log.i(TAG, "run: " + org);
                            if (StringUtils.isNotEmpty(org)) {
                                sendMsg(org+"1", mOutputStream, 120);
                                runOnUiThread(() -> {
                                    tv_send.setText(org);
                                });
//                        mOutputStream.write(packageData(org));
                            }
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                    }
                }, t * 10);

            }

        }

        runOnUiThread(() -> {


            tv_return.setText(data + sb.toString());

            tv_receive.setText("字节码" + sb.toString() + "\n16进制：" + byteArrToHexString(buffer) + "\n字符串：" + data + "\n时间：" + new Date().getTime());
        });

//      if(data.startsWith("$")&&data.endsWith("#")){
//
//      }
    }


    public void control_click(View view) {
        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_SHORT).show();
            return;
        }
        String btnId = getApplication().getResources().getResourceEntryName(view.getId());
        int index = Integer.parseInt(btnId.substring(btnId.indexOf("_") + 1));
        Switch s = findViewById(R.id.s_v);
        StringBuilder sb = new StringBuilder();
        byte[] bytes = new byte[9];
        bytes[0] = 0x24;
        bytes[1] = 0x00;
        bytes[2] = 0x2C;
        bytes[3] = 0x00;
        bytes[4] = 0x00;
        bytes[5] = 0x00;
        bytes[6] = 0x00;
        bytes[7] = 0x46;
        bytes[8] = 0x23;

//        sb.append(str2HexStr("$")).append("0").append(str2HexStr(","));
        if (s.isChecked()) { //开
            int i = ~status[index];
            byte[] intByte = intToBytes(i);
            for (int j = 0; j < intByte.length; j++) {
                bytes[j + 3] = intByte[j];
            }
        } else {
            byte[] intByte = intToBytes(status[index]);
            for (int j = 0; j < intByte.length; j++) {
                bytes[j + 3] = intByte[j];
            }
//            sb.append(String.format("%08X", ));
        }

//        sb.append("F").append(str2HexStr("#"));
        Log.i(TAG, "control_click: " + new String(bytes));
        tv_send.setText(new String(bytes) + ",bytes：" + bytes[0] + "," + bytes[1] + "," + bytes[2] + "," + bytes[3] + "," + bytes[4] + "," + bytes[5] + "," + bytes[6] + "," + bytes[7] + "," + bytes[8]);
        try {
            mOutputStream.write(bytes, 0, bytes.length);
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    public void openDoorLight(View view) {

//        String light_address = this.light_address.getText().toString();
//        if(StringUtils.isEmpty(light_address)){
//
//            Toast.makeText(this,"输入门灯地址", Toast.LENGTH_LONG).show();
//            return;
//
//        }
//        if(mSerialPort==null){
//            Toast.makeText(this,"没打开串口", Toast.LENGTH_LONG).show();
//            return;
//        }
//        String cmd = "$7,"+light_address+"F#";
//        tv_send.setText(cmd);
//        try {
//            mOutputStream.write(cmd.getBytes());
//        } catch (IOException e) {
//            e.printStackTrace();
//        }

        String cmd = "$DOORLED,010F#";
        try {
            mOutputStream.write(cmd.getBytes());
        } catch (IOException e) {
            e.printStackTrace();
        }
//
////        String btnId=getApplication().getResources().getResourceEntryName(view.getId());
////        int index = Integer.parseInt(btnId.substring(btnId.indexOf("_")+1));
////        Switch s = findViewById(R.id.s_v);
//        StringBuilder sb = new StringBuilder();
//        byte[] bytes = new byte[9];
//        bytes[0]=0x24;
//        bytes[1]=0x00;
//        bytes[2]=0x2C;
//        bytes[3]= 0x00;
//        bytes[4]=0x00;
//        bytes[5]=0x00;
//        bytes[6]= 0x00;
//        bytes[7] = 0x46;
//        bytes[8] =0x23;
//
////        sb.append(str2HexStr("$")).append("0").append(str2HexStr(","));
////        if(s.isChecked()){ //开
////            int i = ~status[index];
////            byte[] intByte = intToBytes(i);
////            for (int j = 0; j < intByte.length; j++) {
////                bytes[j+3]=intByte[j];
////            }
////        }else{
////            byte[] intByte = intToBytes(status[index]);
////            for (int j = 0; j < intByte.length; j++) {
////                bytes[j+3]=intByte[j];
////            }
//////            sb.append(String.format("%08X", ));
////        }
//
////        sb.append("F").append(str2HexStr("#"));
////        Log.i(TAG, "control_click: "+new String(bytes));
////        tv_send.setText(new String(bytes)+",bytes："+bytes[0]+","+bytes[1]+","+bytes[2]+","+bytes[3]+","+bytes[4]+","+bytes[5]+","+bytes[6]+","+bytes[7]+","+bytes[8]);
//        try {
//            mOutputStream.write(bytes,0,bytes.length);
//        } catch (IOException e) {
//            e.printStackTrace();
//        }

    }

    public void closeDoorLight(View view) {
        String light_address = this.light_address.getText().toString();
        if (StringUtils.isEmpty(light_address)) {

            Toast.makeText(this, "输入门灯地址", Toast.LENGTH_LONG).show();
            return;

        }
        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_LONG).show();
            return;
        }
        String cmd = "$8," + light_address + "F#";
        tv_send.setText(cmd);
        try {
            mOutputStream.write(cmd.getBytes());
            mOutputStream.write(cmd.getBytes());
        } catch (IOException e) {
            e.printStackTrace();
        }
//
////        String btnId=getApplication().getResources().getResourceEntryName(view.getId());
////        int index = Integer.parseInt(btnId.substring(btnId.indexOf("_")+1));
//        Switch s = findViewById(R.id.s_v);
//        StringBuilder sb = new StringBuilder();
//        byte[] bytes = new byte[9];
//        bytes[0]=0x24;
//        bytes[1]=0x00;
//        bytes[2]=0x2C;
//        bytes[3]= (byte)0xFF;
//        bytes[4]=(byte)0xFF; //17-20
//        bytes[5]=(byte)0xFF; //F0 13-16
//        bytes[6]= (byte)0xFF; //0F 9-12 F0 1-4
//        bytes[7] = 0x46;
//        bytes[8] =0x23;
//
////        sb.append(str2HexStr("$")).append("0").append(str2HexStr(","));
////        if(s.isChecked()){ //开
////            int i = ~status[index];
////            byte[] intByte = intToBytes(i);
////            for (int j = 0; j < intByte.length; j++) {
////                bytes[j+3]=intByte[j];
////            }
////        }else{
////            byte[] intByte = intToBytes(status[index]);
////            for (int j = 0; j < intByte.length; j++) {
////                bytes[j+3]=intByte[j];
////            }
//////            sb.append(String.format("%08X", ));
////        }
//
////        sb.append("F").append(str2HexStr("#"));
////        Log.i(TAG, "control_click: "+new String(bytes));
////        tv_send.setText(new String(bytes)+",bytes："+bytes[0]+","+bytes[1]+","+bytes[2]+","+bytes[3]+","+bytes[4]+","+bytes[5]+","+bytes[6]+","+bytes[7]+","+bytes[8]);
//        try {
//            mOutputStream.write(bytes,0,bytes.length);
//        } catch (IOException e) {
//            e.printStackTrace();
//        }

    }

    public void sipRegistering(View view) {
        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_LONG).show();
            return;
        }
        String cmd = "$3,01F#";
        tv_send.setText(cmd);
        try {
            mOutputStream.write(cmd.getBytes());

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void sipRegisterSuccess(View view) {
        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_LONG).show();
            return;
        }
        String cmd = "$3,11F#";
        tv_send.setText(cmd);
        try {
            mOutputStream.write(cmd.getBytes());

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void sipRegisterFail(View view) {
        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_LONG).show();
            return;
        }
        String cmd = "$3,21F#";
        tv_send.setText(cmd);

        try {
            mOutputStream.write(cmd.getBytes());

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void responsDevice(View view) {

        String device_address = this.device_address.getText().toString();
        if (StringUtils.isEmpty(device_address)) {

            Toast.makeText(this, "输入分机地址", Toast.LENGTH_LONG).show();
            return;

        }
        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_LONG).show();
            return;
        }
        String cmd = "$4," + device_address + "F#";
        tv_send.setText(cmd);
        try {
            mOutputStream.write(cmd.getBytes());

        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    public void handoffDevice(View view) {

        String device_address = this.device_address.getText().toString();
        if (StringUtils.isEmpty(device_address)) {

            Toast.makeText(this, "输入分机地址", Toast.LENGTH_LONG).show();
            return;

        }
        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_LONG).show();
            return;
        }
        String cmd = "$5," + device_address + "F#";
        tv_send.setText(cmd);
        try {
            mOutputStream.write(cmd.getBytes());

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void callinDevice(View view) {

        String device_address = this.device_address.getText().toString();
        if (StringUtils.isEmpty(device_address)) {

            Toast.makeText(this, "输入分机地址", Toast.LENGTH_LONG).show();
            return;

        }
        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_LONG).show();
            return;
        }
        String cmd = "$6," + device_address + "F#";
        tv_send.setText(cmd);
        try {
            mOutputStream.write(cmd.getBytes());

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void broadcastDevice(View view) {


        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_LONG).show();
            return;
        }
        String cmd = "$6,FFFFF#";
        tv_send.setText(cmd);
        try {
            mOutputStream.write(cmd.getBytes());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    public void modeDouble(View view) {
        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_LONG).show();
            return;
        }
        String cmd = "$F,FFFF0#";
        tv_send.setText(cmd);
        try {
            mOutputStream.write(cmd.getBytes());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void modeSingle(View view) {
        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_LONG).show();
            return;
        }
        String cmd = "$F,FFFF1#";
        tv_send.setText(cmd);
        try {
            mOutputStream.write(cmd.getBytes());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void closeEmergency(View view) {
        String device_address = this.device_address.getText().toString();
        if (StringUtils.isEmpty(device_address)) {

            Toast.makeText(this, "输入分机地址", Toast.LENGTH_LONG).show();
            return;

        }
        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_LONG).show();
            return;
        }
        String cmd = "$9," + device_address + "F#";
        tv_send.setText(cmd);
        try {
            mOutputStream.write(cmd.getBytes());

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void sendCustomCommand(View view) {
        String command = this.custom_command.getText().toString();
        if (StringUtils.isEmpty(command)) {

            Toast.makeText(this, "请输入指令", Toast.LENGTH_LONG).show();
            return;

        }
        if (mSerialPort == null) {
            Toast.makeText(this, "没打开串口", Toast.LENGTH_LONG).show();
            return;
        }
        tv_send.setText(command);
        try {
            sendMsg(command, mOutputStream, 120);
//            mOutputStream.write(packageData(command));

        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    public void openNetworkDebug(View view) {
        try {
            Process p = Runtime.getRuntime().exec("su");
            OutputStream op = p.getOutputStream();
            DataOutputStream os = new DataOutputStream(op);
//            os.writeBytes("/system/bin/sh\n");
            os.writeBytes("setprop service.adb.tcp.port 5555\n");
            os.writeBytes("stop adbd\n");
            os.writeBytes("start adbd\n");
            os.writeBytes("exit\n");
            os.flush();
            os.close();
            op.close();
            Log.i("openNetworkDebug", "打开调试:---- ");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String str2HexStr(String str) {
        char[] chars = "0123456789abcdef".toCharArray();
        StringBuilder sb = new StringBuilder();
        byte[] bs = str.getBytes();
        int bit;
        for (int i = 0; i < bs.length; i++) {
            bit = (bs[i] & 0x0f0) >> 4;
            sb.append(chars[bit]);
            bit = bs[i] & 0x0f;
            sb.append(chars[bit]);
            // sb.append(' ');
        }
        return sb.toString().trim();
    }

    public byte[] intToBytes(int a) {
        ByteBuffer bb = ByteBuffer.allocate(4);
        bb.putInt(a);
        return bb.array();
    }


    /**
     * 16进制字符串转换成byte数组
     */
    public byte[] String2Byte(String s) {
        s = s.replace(" ", "");
        s = s.replace("#", "");
        byte[] baKeyword = new byte[s.length() / 2];
        for (int i = 0; i < baKeyword.length; i++) {
            try {
                baKeyword[i] = (byte) (0xff & Integer.parseInt(s.substring(i * 2, i * 2 + 2), 16));
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return baKeyword;
    }

    /**
     * 字节数组转16进制字符串
     *
     * @param b
     * @return
     */
    public String byteArrToHexString(byte[] b) {
        String result = "";
        for (int i = 0; i < b.length; i++) {
            result += Integer.toString((b[i] & 0xff) + 0x100, 16).substring(1);
        }
        return result;
    }
}